#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>

#include <stdio.h>
#include <stdlib.h>

int lung = 1;

int inceput_joc = 0;

int x[10] = {7};
int y[10] = {4};

int orientare = 0;

int hranax, auxx;
int hranay, auxy;

int pa_pini[8] = {PA0, PA1, PA2, PA3, PA4, PA5, PA6, PA7};
int pc_pini[8] = {PC0, PC1, PC2, PC3, PC4, PC5, PC6, PC7};

/* matrice goala */
int matrix0[8][8] =
{
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0}
};


/* matrice de inceput */
int matrix_game[8][8] =
{
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 1, 0, 0, 0}
};

/* litera G */
int matrixover4[8][8] =
{
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 1, 1, 1, 1, 1, 1, 0},
	{0, 1, 0, 0, 0, 0, 0, 0},
	{0, 1, 0, 0, 0, 0, 0, 0},
	{0, 1, 0, 0, 1, 1, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 1, 1, 1, 1, 1, 0},
	{0, 0, 0, 0, 0, 0, 0, 0}
};

/* litera A */
int matrixover5[8][8] =
{
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 1, 1, 1, 1, 0, 0},
	{0, 1, 1, 0, 0, 1, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 1, 1, 1, 1, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 0, 0, 0, 0, 0, 0, 0}
};


/* litera M */
int matrixover6[8][8] =
{
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 1, 0, 0, 1, 1, 0},
	{0, 1, 0, 1, 1, 0, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 0, 0, 0, 0, 0, 0, 0}
};

/* litera E */
int matrixover1[8][8] =
{
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 1, 1, 1, 1, 1, 1, 0},
	{0, 1, 0, 0, 0, 0, 0, 0},
	{0, 1, 1, 1, 1, 1, 1, 0},
	{0, 1, 0, 0, 0, 0, 0, 0},
	{0, 1, 0, 0, 0, 0, 0, 0},
	{0, 1, 1, 1, 1, 1, 1, 0},
	{0, 0, 0, 0, 0, 0, 0, 0}
};

/* litera N */
int matrixover2[8][8] =
{
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 1, 0, 0, 0, 1, 0},
	{0, 1, 0, 1, 0, 0, 1, 0},
	{0, 1, 0, 0, 1, 0, 1, 0},
	{0, 1, 0, 0, 0, 1, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 0, 0, 0, 0, 0, 1, 0}
};

/* litera D */
int matrixover3[8][8] =
{
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 1, 1, 0, 0, 0, 0, 0},
	{0, 1, 0, 1, 0, 0, 0, 0},
	{0, 1, 0, 0, 0, 0, 0, 0},
	{0, 1, 0, 0, 1, 0, 0, 0},
	{0, 1, 0, 1, 0, 0, 0, 0},
	{0, 1, 1, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0}
};







/* Functie pentru afisarea matricei */
void afisare(int matrix[8][8])
{
	int i, j;

	for (i = 0; i < 8; i++) {
		for (j = 0; j < 8; j++)
			if (matrix[j][i])
				PORTC |= (1 << pc_pini[j]);
			else
				PORTC &= ~(1 << pc_pini[j]);

		PORTA &= ~(1 << pa_pini[i]);
		_delay_ms(0.4);
		PORTA |= (1 << pa_pini[i]);
	}
}


/* Functie ce genereaza hrana */
void generare_hrana()
{
	int a, b, i, ok;

	ok = 0;
	while (!ok) {
		ok = 1;
		/* generez doua numere random */
		a = rand() % 8;
		b = rand() % 8;

		/* verific daca punctul e deja ocupat */
		for (i = 0; i < lung; i++)
			if (x[i] == a && y[i] == b) {
					ok = 0;
					break;
			}

		if (ok)
			break;
	}

	hranax = a;
	hranay = b;
}

/* update matrice */
int reactualizare()
{
	if (inceput_joc == 0) {
		inceput_joc=1;
		return 0;
	}

	int i, xaux, yaux;

	xaux = x[lung - 1];
	yaux = y[lung - 1];
	if (orientare == 0) {
		if (!x[0]) matrix_game[7][y[0]] = 1;
		else matrix_game[x[0] - 1][y[0]] = 1;

		for (i = 1; i < lung; i++)
			matrix_game[x[i - 1]][y[i - 1]] = matrix_game[x[i]][y[i]];

		matrix_game[x[lung - 1]][y[lung - 1]] = 0;

		for (i = lung - 1; i > 0; i--) {
			x[i] = x[i - 1];
			y[i] = y[i - 1];
		}

		if (!x[0]) x[0] = 7;
		else x[0] = x[0] - 1;

		if (x[0] == xaux && y[0] == yaux)
			return 1;
	}

	if (orientare == 1) {
		if (x[0] == 7) matrix_game[0][y[0]] = 1;
		else matrix_game[x[0] + 1][y[0]] = 1;

		for (i = 1; i < lung; i++)
			matrix_game[x[i - 1]][y[i - 1]] = matrix_game[x[i]][y[i]];

		matrix_game[x[lung - 1]][y[lung - 1]] = 0;

		for (i = lung - 1; i > 0; i--) {
			x[i] = x[i - 1];
			y[i] = y[i - 1];
		}

		if (x[0] == 7) x[0] = 0;
		else x[0] = x[0] + 1;

		if (x[0] == xaux && y[0] == yaux)
			return 1;
	}

	if (orientare == 2) {
		if (!y[0]) matrix_game[x[0]][7] = 1;
		else matrix_game[x[0]][y[0] - 1] = 1;

		for (i = 1; i < lung; i++)
			matrix_game[x[i - 1]][y[i - 1]] = matrix_game[x[i]][y[i]];

		matrix_game[x[lung - 1]][y[lung - 1]] = 0;

		for (i = lung - 1; i > 0; i--) {
			x[i] = x[i - 1];
			y[i] = y[i - 1];
		}

		if (!y[0]) y[0] = 7;
		else y[0] = y[0] - 1;

		if (x[0] == xaux && y[0] == yaux)
			return 1;
	}

	if (orientare == 3) {
		if (y[0] == 7) matrix_game[x[0]][0] = 1;
		else matrix_game[x[0]][y[0]+ 1] = 1;

		for (i = 1; i < lung; i++)
			matrix_game[x[i - 1]][y[i - 1]] = matrix_game[x[i]][y[i]];

		matrix_game[x[lung - 1]][y[lung - 1]] = 0;

		for (i = lung - 1; i > 0; i--) {
			x[i] = x[i - 1];
			y[i] = y[i - 1];
		}

		if (y[0] == 7) y[0] = 0;
		else y[0] = y[0] + 1;

		if (x[0] == xaux && y[0] == yaux)
			return 1;
	}

	if ((x[0] == hranax) && (y[0] == hranay)) {
		x[lung] = auxx;
		y[lung] = auxy;

		matrix_game[x[lung]][y[lung]] = 1;
		lung++;

		generare_hrana();
		matrix_game[hranax][hranay] = 1;
	}

	/* sfarsit joc */
	for (i = 1; i < lung; i++)
		if (x[i] == x[0] && y[i] == y[0])
			return 1;

	/* retin ultima casuta */
	auxx = x[lung - 1];
	auxy = y[lung - 1];

	return 0;

}


int main()
{
	int i;

	DDRA = 0xFF;
	DDRC = 0xFF;

	PORTA = 0x00;
	PORTC = 0x00;

	for (i = 1; i < 10; i++)
		x[i] = 0, y[i] = 0;

  PORTB |= (1 << PB0);
	DDRB &= ~(1 << PB0);
	PORTB |= (1 << PB1);
	DDRB &= ~(1 << PB1);
	PORTB |= (1 << PB2);
	DDRB &= ~(1 << PB2);
	PORTB |= (1 << PB3);
	DDRB &= ~(1 << PB3);
	PORTB |= (1 << PB4);
	DDRB &= ~(1 << PB4);


	DDRA = 0xFF;
	DDRC = 0xFF;

	PORTA = 0x00;
	PORTC = 0x00;


	while(1) {

		if (!(PINB & (1 << PB4))) break;
	}
	generare_hrana();
	matrix_game[hranax][hranay] = 1;

	DDRA = 0xFF;
	DDRC = 0xFF;

	PORTA = 0x00;
	PORTC = 0x00;

	while (1) {
		int x1 = 0, x2 = 0;
		i = 0;

		/* Inceputul jocului */
		while (x1 < 8 && x2 < 8) {
			matrix0[x2][x1] = 1;
			i = 0;

			while(i < 10) {
				afisare(matrix0);
				++i;
			}

			if (!(x1 % 2)) ++x2;
			else --x2;

			if (x2 == 8) {
				x2 = 7;
				++x1;
			}
			if (x2 == - 1) {
				x2 = 0;
				++x1;
			}
		}


		while(1) {
			int i = 0;
			int dir_actuala = orientare;
			int ts = 200;

			while(i < ts) {
				afisare(matrix_game);
				i++;
				/* apasare buton in functie de orientare*/
				if (!(PINB & (1 << PB0)))
					if ((dir_actuala == 2) || (dir_actuala == 3))
						orientare = 0;
				if (!(PINB & (1 << PB1)))
					if ((dir_actuala == 0) || (dir_actuala == 1))
						orientare = 3;
				if (!(PINB & (1 << PB2)))
					if ((dir_actuala == 0) || (dir_actuala == 1))
						orientare = 2;
				if (!(PINB & (1 << PB3)))
					if ((dir_actuala == 2) || (dir_actuala == 3))
						orientare = 1;
			}

			int ok = reactualizare();

			/* jocul se incheie */
			if (ok == 1) {
				int timp = 150;

				while(1) {
					for (i = 0; i < timp; i++)
						afisare(matrixover1);
					for (i = 0; i < timp; i++)
						afisare(matrixover2);
					for (i = 0; i < timp; i++)
						afisare(matrixover3);
					for (i = 0; i < timp; i++)
						afisare(matrixover4);
					for (i = 0; i < timp; i++)
						afisare(matrixover5);
					for (i = 0; i < timp; i++)
						afisare(matrixover6);
					for (i = 0; i < timp*2; i++)
						afisare(matrixover1);


				}
			}
		}
	}

	return 0;
}
